if not LibStub then return end
local function round(num, places)
	return tonumber(string.format("%."..(places or 0).."f",num))
end
local aprilfools
local gsloaded = IsAddOnLoaded("GearScore")
local slots = {BackSlot=true, ChestSlot=true, FeetSlot=true, Finger0Slot=true, Finger1Slot=true, HandsSlot=true, HeadSlot=true, LegsSlot=true, MainHandSlot=true, NeckSlot=true, RangedSlot=true, SecondaryHandSlot=true, Trinket0Slot=true, Trinket1Slot=true, WaistSlot=true, WristSlot=true}
local numeric = {}
for slot in pairs(slots) do
	numeric[GetInventorySlotInfo(slot)] = slot
end
local LibNameplate = LibStub("LibNameplate-1.0")
if not EPEEN then EPEEN = CreateFrame("Frame") end
local addon = EPEEN or CreateFrame("Frame")
addon.plates = {}
function addon:UpdatePeen(name, plate)
	if not plate.epeen then return end
	if not self.db.max then return end
	local peen = plate.epeen
	if self.db[name] then
		peen:SetHeight(((self.db[name].avg-self.db.opt.orient)/(self.db.max-self.db.opt.orient))*150+(aprilfools and 35 or 20))
		local avg = self.db[name].avg
		local pavg = self.db[UnitName("player")] and self.db[UnitName("player")].avg
		peen.num:SetText(avg)
		if aprilfools then
			peen.type:SetText(pavg and (avg > pavg and "N\nO\nL\nI\nF\nE" or avg < pavg and "N\n0\n0\nB"))
		end
		peen.tex:Show()
		peen.tex3:Show()
		peen.tex4:Show()
		peen.num:Show()
		peen.type:Show()
		peen.tex2:SetAlpha(1)
	elseif gsloaded and GS_Data[GetRealmName()].Players[name] then
		local avg = GS_Data[GetRealmName()].Players[name].Average
		if avg > self.db.max then
			self.db.max = avg
			self:UpdateAllPeens()
		end
		local pavg = GS_Data[GetRealmName()].Players[UnitName("player")] and GS_DATA[GetRealmName()].Players[UnitName("player")].Average or self.db[UnitName("player")] and self.db[UnitName("player")].avg
		peen.num:SetText(avg)
		if aprilfools then
			peen.type:SetText(pavg and (avg > pavg and "N\nO\nL\nI\nF\nE" or avg < pavg and "N\n0\n0\nB"))
		end
		peen.tex:Show()
		peen.tex3:Show()
		peen.tex4:Show()
		peen.num:Show()
		peen.type:Show()
		peen.tex2:SetAlpha(1)
	else
		peen:SetHeight(aprilfools and 35 or 20)
		peen.tex:Hide()
		peen.tex3:Hide()
		peen.tex4:Hide()
		peen.num:Hide()
		peen.type:Hide()
		peen.tex2:SetAlpha(0.4)
	end
end
function addon:UpdateAllTextures()
	for num, peen in pairs(addon.plates) do
		peen:UpdateTextures()
	end
end
function addon:UpdateAllPeens()
	for num, peen in pairs(addon.plates) do
		if peen:IsVisible() then
			local name = LibNameplate:GetName(peen.plate)
			if name then
				self:UpdatePeen(name, peen.plate)
			end
		end
	end
end
function addon:LibNameplate_NewNameplate(event, namePlate)
	if (LibNameplate:GetType(namePlate) ~= "PLAYER") or (LibNameplate:GetReaction(namePlate) == "HOSTILE") then if namePlate.epeen then namePlate.epeen:Hide() end return end
	if LibNameplate:GetLevel(namePlate) < self.db.opt.minlvl then if namePlate.epeen then namePlate.epeen:Hide() end return end
	local name = LibNameplate:GetName(namePlate)
	if not namePlate.epeen then
		local f = CreateFrame("Frame", nil, namePlate)
		f:SetWidth(aprilfools and 35 or 20)
		f:SetPoint("BOTTOM", namePlate, "TOP", 0, -5)
		f.tex = f:CreateTexture(nil, "BACKGROUND")
		f.tex2 = f:CreateTexture(nil, "BACKGROUND")
		f.tex2:SetTexture("Interface\\LFGFrame\\UI-LFG-ICON-ROLES")
		f.tex2:SetTexCoord(0.26171875, 0.26171875, 0.26171875, 0.5234375, 0.5234375, 0.26171875, 0.5234375, 0.5234375)
		f.tex2:SetPoint("BOTTOMLEFT")
		f.tex2:SetPoint("TOPRIGHT", f, "BOTTOMRIGHT", 0, aprilfools and 35 or 20)
		f.tex:SetPoint("BOTTOMRIGHT", f.tex2, "TOPRIGHT")
		f.tex3 = f:CreateTexture(nil, "BACKGROUND")
		f.tex4 = f:CreateTexture(nil, "BACKGROUND")
		f.tex4:SetPoint("TOPLEFT", f.tex, "BOTTOMLEFT")
		f.tex4:SetPoint("BOTTOMRIGHT", f.tex2, "TOPRIGHT")
		f.tex4:SetTexture("Interface\\AddOns\\EPEEN\\bot")
		f.num = f:CreateFontString(nil, "ARTWORK")
		f.num:SetPoint("BOTTOM", f, "TOP", 0, 5)
		f.num:SetFont("Fonts\\FRIZQT__.TTF", 15, "OUTLINE")
		f.num:SetTextColor(0.8,0.8,0.8)
		f.type = f:CreateFontString(nil, "ARTWORK")
		f.type:SetPoint("TOP")
		f.type:SetPoint("BOTTOM", 0, aprilfools and 35 or 20)
		f.type:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
		f.type:SetTextColor(1,0,0,0.8)
		--Credit to Me0w of mmo-champion.com for this texture
		if not aprilfools then
			function f:UpdateTextures()
				local db = addon.db[LibNameplate:GetName(self.plate)]
				local cls = db and db.class
				self.tex:SetTexture("Interface\\AddOns\\EPEEN\\"..(cls and cls.."\\" or "").."mid")
				self.tex3:SetTexture("Interface\\AddOns\\EPEEN\\"..(cls and cls.."\\" or "").."top")
				self.tex4:SetTexture("Interface\\AddOns\\EPEEN\\"..(cls and cls.."\\" or "").."bot")
			end
		else
			function f:UpdateTextures()
				self.tex:SetTexture(1,1,0)
				self.tex3:SetTexture("Interface\\AddOns\\EPEEN\\head")
			end
		end
		f.tex3:SetPoint("TOPLEFT", aprilfools and -4 or 0, 0)
		f.tex3:SetPoint("BOTTOMRIGHT", f.tex, "TOPRIGHT", aprilfools and 2 or 0, 0)
		f.tex:SetPoint("TOPLEFT", 0, aprilfools and -35 or  -20)
		f.tex:SetPoint("BOTTOMRIGHT", f.tex2, "TOPRIGHT", 0, aprilfools and 0 or 20)
		f.plate = namePlate
		f:UpdateTextures()
		namePlate.epeen = f
		tinsert(addon.plates, f)
	else
		namePlate.epeen:Show()
		namePlate.epeen:UpdateTextures()
	end
	self:UpdatePeen(name, namePlate)
end
function addon:LibNameplate_RecycleNameplate(event, namePlate)
	if not namePlate.epeen then return end
	namePlate.epeen:Hide()
end
function addon:DoInspect(unit)
	if (not UnitExists(unit)) or (not CanInspect(unit)) then return end
	local name = UnitName(unit)
	NotifyInspect(unit)
	if not self.db[name] then self.db[name] = {} end
	local d = self.db[name]
	d.class = (select(2, UnitClass(unit)))
	d.items={}
	for id in pairs(numeric) do
		local iid = GetInventoryItemID(unit, id)
		if iid then
			local ilvl = (select(4, GetItemInfo(iid)))
			d.items[id] = ilvl
		end
	end
	local sum, num = 0,0
	for slot, lvl in pairs(d.items) do
		sum = sum+lvl
		num = num+1
	end
	d.avg = round(sum/num, 0)
	ClearInspectPlayer()
	if d.avg > self.db.max then
		self.db.max = d.avg
		self:UpdateAllPeens()
	else
		local n = LibNameplate:GetNameplateByUnit(unit)
		if n then
			self:UpdatePeen(name, n)
			if n.epeen then
				n.epeen:UpdateTextures()
			end
		end
	end
end
LibNameplate.RegisterCallback(addon, "LibNameplate_NewNameplate")
LibNameplate.RegisterCallback(addon, "LibNameplate_RecycleNameplate")
addon:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD" then
		local wday, month, day, year = CalendarGetDate()
		if month == 4 and day == 1 then aprilfools = true else aprilfools = nil end
		return
	end
	local defaults = {minlvl=80, orient=150}
	if not EPEEN_DB	then EPEEN_DB = {opt={}} end
	if not EPEEN_DB[GetRealmName()] then EPEEN_DB[GetRealmName()] = {max=0, opt={}} end
	self.db = EPEEN_DB[GetRealmName()]
	if not self.db.opt then self.db.opt = {} end
	self.db.opt = setmetatable(self.db.opt, {__index=function(t,v) t[v]=defaults[v] return t[v] end})
	self:UnregisterEvent("ADDON_LOADED")
	self:SetScript("OnEvent", function(self, event, ...)
		if InCombatLockdown() then return end
		if event == "PLAYER_ENTERING_WORLD" then
			local wday, month, day, year = CalendarGetDate()
			if month == 4 and day == 1 then aprilfools = true else aprilfools = nil end
		elseif event == "UPDATE_MOUSEOVER_UNIT" then
			self:DoInspect("mouseover")
		elseif event == "PLAYER_FOCUS_CHANGED" then
			self:DoInspect("focus")
		elseif event == "PLAYER_TARGET_CHANGED" then
			self:DoInspect("target")
		elseif event == "UNIT_INVENTORY_CHANGED" then
			self:DoInspect("player")
		end
	end)
	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED")
	self:RegisterEvent("PLAYER_FOCUS_CHANGED")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
end)
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("PLAYER_ENTERING_WORLD")

SlashCmdList["EPEEN"] = function(input)
	local cmd, args = string.match(input, "(%S+) (%S+)")
	if not cmd then cmd = input end
	if cmd == "whatsmine" then
		print("Your E.P.E.E.N. is "..EPEEN_DB[GetRealmName()][UnitName("player")].avg.."!"..(aprilfools and " You're so awesome!" or ""))
	else
		LibStub("AceConfigDialog-3.0"):Open("EPEEN")
	end
end
SLASH_EPEEN1 = "/epeen"
SLASH_EPEEN2 = "/peen"
LibStub("AceConfig-3.0"):RegisterOptionsTable("EPEEN", {
	type='group',
	args={
		minlvl = {
			name="Minimum level",
			type="range",
			desc="Minimum level to display a bar for",
			min=1,
			max=80,
			step=1,
			bigStep=1,
			get=function()
				return addon.db.opt.minlvl
			end,
			set = function(info, value)
				addon.db.opt.minlvl = value
			end,
		},
		orient = {
			name="Orientate",
			type="range",
			desc="Scale bars by difference towards this ilvl",
			min=100,
			max=200,
			step=5,
			get=function()
				return addon.db.opt.orient
			end,
			set=function(info, value)
				addon.db.opt.orient = value
				addon:UpdateAllPeens()
			end,
		}
	}
})